#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=..\..\..\Icons\Deckard-Cain.ico
#AutoIt3Wrapper_Res_Comment=Diablo 2 Message Logger
#AutoIt3Wrapper_Res_Description=Diablo 2 Message Logger
#AutoIt3Wrapper_Res_Fileversion=1.2
#AutoIt3Wrapper_Res_Language=1033
#AutoIt3Wrapper_Res_requestedExecutionLevel=requireAdministrator
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.2.0

Game Log Version 1.1 by PortalDeamon000
updated March 23rd, 2010

#ce ----------------------------------------------------------------------------


#include <Date.au3>
#include <NomadMemory.au3>

Opt("WinTitleMatchMode", 3)  ;; exact match
Opt("TrayAutoPause",0)

Global Const $VersionInfo = '1.2'
Global $OFFSET_D2CLIENT_LAST_CHAT_MSG = 0x101AA0
Global $Handle, $oldptr1, $oldptr2, $oldmsg
Global $window, $winhandle, $Handle
Global $d2clientdll = 0

$gui = GuiCreate("GameLog v" & $VersionInfo, 300,100,-1,-1)
$button_1 = GuiCtrlCreateButton("Run", 10, 10, 100, 50)
$button_2 = GUICtrlCreateButton("Help - How to Use", 10, 65, 100, -1)
$button_3 = GUICtrlCreateButton("Settings", 115, 45, 60, 50)
$button_4 = GuiCtrlCreateButton("Cancel", 180, 10, 100, 50)
$button_5 = GUICtrlCreateButton("Check For Updates", 180, 65, 100, -1)
GUISetState()

While 1
	$msg = GUIGetMsg()
	Select
		Case $msg = $button_1
			GUIDelete($gui)
            _run()
		Case $msg = $button_2
            ShellExecute("readme.txt")
		Case $msg = $button_3
            ShellExecute("gamelogsetting.ini")
		Case $msg = $button_4
            Exit
		Case $msg = $button_5
			_Update()
		Case $msg = -3
            Exit
		EndSelect
WEnd

Func _run()
	$window = IniRead("GameLogSetting.ini","GameLog","window","Diablo II")
	if Not WinExists($window) Then
		MsgBox(4096, "ERROR", "Diablo Game appears not to be running. Please edit your GameLogSettings.ini to the correct title.")
		Exit
	EndIf
	$winhandle = WinGetHandle($window)

	_SetPrivilege ("SeDebugPrivilege", 1)
	$Handle = _MemoryOpen (GetD2ProcessID())

	while 1
		Local $msg = GetLastChatMessage()
		if $msg <> "" Then
			$msg = StringReplace(StringReplace($msg,"c4",""),"c0","")
			FileWriteLine("GameLog.txt",_NowCalc() & " " & $msg)
		EndIf
		Sleep(25)
	WEnd
EndFunc

Func OnAutoItExit ()
	_MemoryClose ($Handle)
EndFunc

Func GetLastChatMessage()
	if $d2clientdll == 0 Then
		Sleep(100)
		$d2clientdll = _ProcessGetLoadedModules(GetD2ProcessID(),"d2client.dll")
		if @error Then
			SetError(1)
			Return -1
		EndIf
		Sleep(100)
	EndIf

    Local $pointer1 = _MemoryRead ($d2clientdll + $OFFSET_D2CLIENT_LAST_CHAT_MSG, $Handle, 'dword')
    Local $pointer2 = _MemoryRead ($pointer1, $Handle, 'dword')
    Local $Temp = _MemoryReadWideString ($pointer2, $Handle, 'ushort[396]')
	If ($oldptr1 == $pointer1) And ($oldptr2 == $pointer2) And ($oldmsg == $Temp) Then
		Return ""
	Else
		$oldptr1 = $pointer1
		$oldptr2 = $pointer2
		$oldmsg = $Temp
		Return $Temp
	EndIf
EndFunc   ;==>GetLastChatMessage

Func _ProcessGetLoadedModules($iPID,$dllname)
    Local Const $PROCESS_QUERY_INFORMATION=0x0400
    Local Const $PROCESS_VM_READ=0x0010
    Local $aCall, $hPsapi=DllOpen("Psapi.dll")
    Local $hProcess, $tModulesStruct
    $tModulesStruct=DllStructCreate("hwnd [200]")
    Local $SIZEOFHWND = DllStructGetSize($tModulesStruct)/200
    $hProcess=_WinAPI_OpenProcess(BitOR($PROCESS_QUERY_INFORMATION,$PROCESS_VM_READ),False,$iPID)
    if @error Then
		_WinAPI_CloseHandle($hProcess)
		DllClose($hPsapi)
		Return SetError(1,0,-1)
	EndIf
    $aCall=DllCall($hPsapi,"int","EnumProcessModules","ptr",$hProcess,"ptr",DllStructGetPtr($tModulesStruct),"dword",DllStructGetSize($tModulesStruct),"dword*","")
    If $aCall[4]>DllStructGetSize($tModulesStruct) Then
        $tModulesStruct=DllStructCreate("hwnd ["&$aCall[4]/$SIZEOFHWND&"]")
        $aCall=DllCall($hPsapi,"int","EnumProcessModules","ptr",$hProcess,"ptr",DllStructGetPtr($tModulesStruct),"dword",$aCall[4],"dword*","")
    EndIf
	if $aCall[4] <= $SIZEOFHWND Then
		_WinAPI_CloseHandle($hProcess)
		DllClose($hPsapi)
		Return SetError(1,0,-1)
	EndIf
    Local $aReturn[Int($aCall[4]/$SIZEOFHWND)]
	Local $returnval = 0
    For $i=0 To Ubound($aReturn)-1
        $aCall=DllCall($hPsapi,"dword","GetModuleFileNameExW","ptr",$hProcess,"int",DllStructGetData($tModulesStruct,1,$i+1),"wstr","","dword",65536)
		if (StringRight($aCall[3]	,StringLen($dllname)+1) = "\" & $dllname) Then
;~ 			MsgBox(0,$i,$aCall[3] & @CRLF & DllStructGetData($tModulesStruct,1,$i+1))
			$returnval = DllStructGetData($tModulesStruct,1,$i+1)
		EndIf
        $aReturn[$i]=$aCall[3]
    Next
    _WinAPI_CloseHandle($hProcess)
    DllClose($hPsapi)
    Return $returnval
EndFunc

Func GetD2ProcessID()
    $ProcID = WinGetProcess($winhandle, "")
    If $ProcID = -1 Then
        MsgBox(4096, "ERROR", "Diablo Game appears not to be running. Exiting...")
        Exit
    EndIf
    Return $ProcID
EndFunc   ;==>GetD2ProcessID

; by PortalDeamon000
Func _Update()
	FileDelete(@ScriptDir & "\version.dat")
	InetGet("http://www.portaldeamon.com/VersionGL.txt", @ScriptDir & "\version.dat", 1, 0)
	$version = FileRead(@ScriptDir & "\version.dat")
	Local $size = FileGetSize(@ScriptDir & "\version.dat")
	if ($size < 3) Or ($size > 30) Then
		FileDelete(@ScriptDir & "\version.dat")
		MsgBox(48, "Updater", "ERROR!" & @CRLF & "Update Site Not Found")
		Return
	EndIf
	if $version = $VersionInfo Then
		FileDelete(@ScriptDir & "\version.dat")
		MsgBox(0, "Updater", "No New Updates")
		Return
	Else
		FileDelete(@ScriptDir & "\version.dat")
		$return = MsgBox(49, $VersionInfo, $version & " is avaiable for download." & @CRLF & "Click OK to download." )
		if $return = 1 Then ShellExecute("http://www.portaldeamon.com/gamelog.zip")
		Return
	EndIf
EndFunc
